/*hdr
**      FILE:           Ted.h
**      AUTHOR:         Matthew Allen
**      DATE:           23/4/98
**      DESCRIPTION:    TextEditor header
**
**      Copyright (C) 1998, Matthew Allen
**              fret@ozemail.com.au
*/

#ifndef __TED_H
#define __TED_H

#include "GTextView2.h"
#include "GDocApp.h"

/////////////////////////////////////////////////////////////////////////////
#define VER						2.10

/////////////////////////////////////////////////////////////////////////////
#define IDM_PRINT				103
#define IDM_PRINTSETUP			104

#define IDM_UNDO				200
#define IDM_REDO				201
#define IDM_CUT					202
#define IDM_COPY				203
#define IDM_PASTE				204
#define IDM_FIND				205
#define IDM_REPLACE				206
#define IDM_USE_CRLF			207
#define IDM_WORD_WRAP			208
#define IDM_SP_TO_TAB			209
#define IDM_FONT				210

#define IDM_HELP				900
#define IDM_ABOUT				901

#define WM_NEXT					(WM_USER + 2)

/////////////////////////////////////////////////////////////////////////////
extern char *AppName;

/////////////////////////////////////////////////////////////////////////////
class StringList : public List<char> {
public:
	void Empty()
	{
		for (char *p = First(); p; p = Next())
		{
			DeleteArray(p);
		}
	}
};

/////////////////////////////////////////////////////////////////////////////
class Ted :
	public GDocApp
{
	// menu
	GMenuItem *UseCrLf;
	GMenuItem *WordWrap;

	// views
	GSplitter *Split;
	GTextView *Text;
	GStatusBar *Status;
	GStatusPane *StatusInfo[3];

public:
	Ted();
	~Ted();

	void OnReceiveFiles(List<char> &Files);
	void GetFileTypes(GFileSelect *Dlg, bool Write);

	bool OpenFile(char *Name);
	bool SaveFile(char *Name);
	void SetStatus(int Pos, char *Text);
	void OnFocus(bool b);

	int OnEvent(GMessage *Msg);
	void OnKey(VKey &K);
	int OnCommand(int Cmd, int Event, GWndRef Wnd);
	int OnNotify(GView *Ctrl, int Flags);
};

#endif