/*hdr
**      FILE:           TedMain.cpp
**      AUTHOR:         Matthew Allen
**      DATE:           23/4/98
**      DESCRIPTION:    Text EDitor main function
**
**      Copyright (C) 1998, Matthew Allen
**              fret@ozemail.com.au
*/

#include <stdio.h>
#include "Lgi.h"
#include "Ted.h"

#ifdef WIN32
int
WINAPI
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	CoInitialize(NULL);

	MemoryDevice Memory;
	FileDevice File;
	GdcDevice Gdc;

	{
		App a(hInstance, lpCmdLine, nCmdShow);
		a.AppWnd = NEW(Ted);
		a.OnCmdLine(lpCmdLine);
		a.Run();
	}

	CoUninitialize();

	return 0;
}
#else if BEOS
int main(int Args, char **Arg)
{
	char Parm[256] = "";
	for (int i=1; i<Args; i++)
	{
		if (strlen(Parm)>0) strcat(Parm, " ");
		strcat(Parm, Arg[i]);
	}
	
	App *a = NEW(App("application/Ted", 0));
	if (a)
	{
		MemoryDevice Memory;
		FileDevice File;
		GdcDevice Gdc;

		a->AppWnd = NEW(Ted);
		a->OnCmdLine(Parm);
		a->Run();
		
		DeleteObj(a);
	}

	return 0;
}
#endif

