// Device.h
#ifndef _DEVICE_H
#define _DEVICE_H

#include <BeBuild.h>
#include <OS.h>

class GDevice {

	static GDevice *First;
	GDevice	*Next, *Prev;

protected:
	static bool AddDevice(GDevice *pDev);
	static bool RemoveDevice(GDevice *pDev);
	bool	Print(char *str, ...);
	void	CriticalExit(char *str, ...);

	char		Name[16];
	static bool	Verbose;

public:
	GDevice();
	virtual ~GDevice();

	static GDevice *FindDevice(char *Name);
	static bool SetVerbose(bool v);
};

////////////////////////////////////////////////////////////////
class DoEvery {

	int64 LastTime;
	int64 Period;

public:
	// p = timeout in ms
	DoEvery(int p = 1000);
	void Init(int p = -1);
	bool DoNow();
};

#endif
