//////////////////////////////////////////////////////////////////////////////////
GCombo::GCombo(int id, int x, int y, int cx, int cy, char *name) :
	GControl(this),
	BMenuField(BRect(0, 0, 1, 1), "Combo", "", new BMenu(""))
#ifdef LGI_RES
	, ResObject(Res_ComboBox)
#endif
{
	SetId(id);
	Pos.Set(x, y, x+cx, y+min(cy, 20));
	SortItems = FALSE;
	CurItem = 0;
	InitIndex = 0;

	DefaultViewColour();
}

GCombo::~GCombo()
{
}

char *GCombo::Name()
{
	return (char*) MenuItem()->Label();
}

bool GCombo::Name(char *n)
{
	MenuItem()->SetLabel(n);
	return TRUE;
}

void GCombo::Value(int i)
{
	char Str[32];
	sprintf(Str, "%i", i);
	Name(Str);
}

int GCombo::Value()
{
	return atoi(Name());
}

void GCombo::Index(int i)
{
	InitIndex = i;
	if (GetBView()->LockLooper())
	{
		if (Menu() AND MenuItem())
		{
			CurItem = Menu()->ItemAt(i);
			if (CurItem AND
				CurItem->Label())
			{
				MenuItem()->SetLabel(CurItem->Label());
			}
		}
		
		GetBView()->UnlockLooper();
	}
}

int GCombo::Index()
{
	int Status = InitIndex;
	if (GetBView()->LockLooper())
	{
		Status = Menu()->IndexOf(CurItem);
		GetBView()->UnlockLooper();
	}
	return Status;
}

int GCombo::OnEvent(BMessage *Msg)
{
	if (Msg->what == WM_CHANGE)
	{
		CurItem = 0;
		Msg->FindPointer("source", (void**) &CurItem);
		if (CurItem)
		{
			MenuItem()->SetLabel(CurItem->Label());
			
			GView *Tell = (Notify) ? Notify : GView::Parent;
			if (Tell)
			{
				Tell->OnNotify(this, 0);
			}
		}
	}
	return 0;
}

bool GCombo::Delete()
{
	int32 Index = (Cur) ? FindIndex(Cur->Ptr) : -1;
	bool Status = DLinkList::Delete();

	if (Status AND Index >= 0)
	{
		Menu()->RemoveItem(Index);
	}

	return Status;
}

bool GCombo::Delete(int i)
{
	bool Status = DLinkList::Delete(i);

	if (Status)
	{
		Menu()->RemoveItem((int32) i);
	}

	return Status;
}

bool GCombo::Delete(char *p)
{
	int32 Index = FindIndex(p);
	bool Status = DLinkList::Delete((void*)p);

	if (Status AND Index >= 0)
	{
		Menu()->RemoveItem(Index);
	}

	return Status;
}

void GCombo::OnCreate()
{
	BMenuField::AttachedToWindow();
	BMenu *m = Menu();
	if (m)
	{
		for (int32 i=0; i<m->CountItems(); i++)
		{
			BMenuItem *Item = m->ItemAt(i);
			Item->SetTarget(this);
		}
	}

	Index(InitIndex);
}

bool GCombo::Insert(char *p, int Index)
{
	if (NOT p) p = "";
	bool Status = DLinkList::Insert((void*)p, Index);
	BMessage *Msg = 0;
	BMenuItem *Item = NEW(BMenuItem(p, Msg = NEW(BMessage(WM_CHANGE))));
	if (Item)
	{
		Menu()->AddItem(Item, (Index<0)?Menu()->CountItems():Index);
		Item->SetTarget(this);
	}

	return Status;
}

