#ifndef __GFILE_SELECT_H
#define __GFILE_SELECT_H

///////////////////////////////////////////////////////////////////////////////////////////////////
// File select dialog
class LgiClass GFileType : public GObject {

	char *Ext;
	int _Data;

public:
	GFileType()
	{
		Ext = 0;
		_Data = 0;
	}

	~GFileType()
	{
		DeleteObj(Ext);
	}

	char *Extension() { return Ext; }
	bool Extension(char *e)
	{
		return (Ext = NewStr(e)) != 0;
	}

	char *Description() { return Name(); }
	bool Description(char *d) { return Name(d); }

	int Data() { return _Data; }
	void Data(int i) { _Data = i; }
};

class LgiClass GFileSelect :
#ifdef BEOS
	public BHandler,
#endif
	public GObject
{

	#ifdef BEOS

	BFilePanel		*Panel;
	BMessenger		*Messenger;
	bool			MultiSel;
	char			*InitDir;
	char			*DefExt;
	char			*TitleStr;
	bool			WaitForMessage;

	void Wait();
	void MessageReceived(BMessage *message);
	bool DoDialog(file_panel_mode Mode, int32 NodeType = B_FILE_NODE);

	#elif defined WIN32
	
	OPENFILENAME	Info;

	char *TypeStr();

	#endif

	int				Size;
	char			*FileStr;
	List<GFileType>	TypeList;
	GView		*ParentWnd;

public:
	GFileSelect();
	~GFileSelect();

	// Properties
	char *Name();
	bool Name(char *n);
	char *operator [](int i);
	int Names();
	char *File();
	char *Extension();
	GView *Parent();
	void Parent(GView *Window);
	bool MultiSelect();
	void MultiSelect(bool Multi);
	char *InitialDir();
	void InitialDir(char *InitDir);
	char *Title();
	void Title(char *Title);
	char *DefaultExtension();
	void DefaultExtension(char *DefExt);

	// File types
	int Types();
	int SelectedType();
	GFileType *TypeAt(int n);
	bool Type(char *Description, char *Extension, int Data = 0);
	void ClearTypes();

	// Methods
	bool Open();
	bool Save();
	bool OpenFolder();
};

#endif