#ifndef __GLIBRARY_H
#define __GLIBRARY_H

// Os specific wrapper typedefs/defines
#ifdef WIN32

	// Win32
	typedef HMODULE _SysLibHandle;
	#define _SysDefLibExtension ".dll"

#else

	// Unix-like systems

	#if defined BEOS
	typedef image_id _SysLibHandle;
	#else // atheos/linux
	typedef int _SysLibHandle;
	#endif

	#define _SysDefLibExtension ".so"

#endif

// Generic shared library loader
class LgiClass GLibrary
{
	char *FileName;
	_SysLibHandle hLib;

public:
	GLibrary(char *File = 0);
	virtual ~GLibrary();

	_SysLibHandle Handle() { return hLib; }
	char *GetFileName() { return FileName; }
	bool IsLoaded() { return hLib != 0; }

	bool Load(char *File);
	bool Unload();
	void *GetAddress(char *Resource);
};

#endif