#ifndef __GMRU_H
#define __GMRU_H

// Message defines
#define IDM_GMRU_BASE		15000
#define	IDM_OPEN			(IDM_GMRU_BASE+0)
#define	IDM_SAVEAS			(IDM_GMRU_BASE+1)

// Classes
class LgiClass GMru
{
private:
	int _Size;
	List<char> _Items;
	GSubMenu *_Parent;
	GFileType *_SelectedType;
	GFileSelect _Select;
	
	void _Update();

protected:
	virtual bool _OpenFile(char *File);
	virtual bool _SaveFile(char *File);

	virtual void GetFileTypes(GFileSelect *Dlg, bool Write);
	virtual GFileType *GetSelectedType() { return _SelectedType; }

public:
	GMru();
	virtual ~GMru();

	// Impl
	bool Set(GSubMenu *parent, int size = -1);
	bool Serialize(ObjProperties *Props, char *Prefix, bool Write);
	char *AddFile(char *FileName, bool Update = true);
	void RemoveFile(char *FileName, bool Update = true);
	int OnEvent(GMessage *Msg);

	// Events
	virtual bool OpenFile(char *FileName) = 0;
	virtual bool SaveFile(char *FileName) = 0;
};

#endif