/////////////////////////////////////////////////////////////////////////////////////////
class LgiClass ProgressList : public List<Progress> {

	bool InUse;

public:
	ProgressList();

	bool Lock();
	void Unlock();
};

class LgiClass GProgressPane : public Progress, public GLayout {

	friend class GProgressDlg;

	Progress *Ref;

protected:
	bool Wait;

	GText *Desc;
	GText *ValText;
	GText *Rate;
	GProgress *Bar;
	GButton *But;

public:
	GProgressPane();
	~GProgressPane();

	char *GetDescription();
	void SetDescription(char *d);
	void GetLimits(int *l, int *h) { Progress::GetLimits(l, h); }
	void SetLimits(int l, int h);
	int Value() { return Progress::Value(); }
	void Value(int v);
	GFont *GetFont();

	void OnCreate();
	int OnNotify(GView *Ctrl, int Flags);
	void OnPaint(GdcBasePrimitives *pDC);
	bool Pour(GdcComplexRegion &r);
};

class LgiClass GProgressDlg : public GDialog {
protected:
	bool Wait;
	List<GProgressPane> Progri;

public:
	GProgressDlg(GView *parent = 0, bool wait = FALSE);
	~GProgressDlg();

	GProgressPane *Push();
	void Pop(GProgressPane *p = 0);
	GProgressPane *ItemAt(int i);


	char *GetDescription();
	void SetDescription(char *d);
	void GetLimits(int *l, int *h);
	void SetLimits(int l, int h);
	double GetScale();
	void SetScale(double s);
	int Value();
	void Value(int v);
	char *GetType();
	void SetType(char *t);
	bool Cancel();

	void OnSync(ProgressList *Prg);

	int OnEvent(GMessage *Msg);
	void OnPaint(GdcBasePrimitives *pDC);
	void OnCreate();
};
