#ifndef __GSEMAPHORE_H
#define __GSEMAPHORE_H

// Thread Type and Functions
#if defined WIN32

	typedef DWORD LgiThreadId;
	#define LgiGetCurrentThread()		GetCurrentThreadId()

#elif defined BEOS

	typedef thread_id LgiThreadId;
	#define LgiGetCurrentThread()		find_thread(0)

#else

	typedef int LgiThreadId;

#endif

// Resource Locking Class
class LgiClass GSemaphore
{
protected:
	LgiThreadId _Thread;
	int _Count;

	#if defined BEOS

	sem_id _Sem;

	#elif defined WIN32

	HANDLE _Mutex;

	#endif

	bool _Lock();
	void _Unlock();

public:
	GSemaphore();
	virtual ~GSemaphore();

	bool Lock();
	bool LockWithTimeout(int Timeout /* in ms */);
	void Unlock();
};

#endif
