#ifndef __GZIP_LIB_H
#define __GZIP_LIB_H

#include "..\Zip32\api.h"

class GLogTarget
{
public:
	virtual void ClearLog() = 0;
	virtual void Log(char *Str, COLOUR c = Rgb24(0, 0, 0)) = 0;
};

class GZipLibrary : public GLibrary
{
	typedef void	(EXPENTRY *_ZpVersion)(ZpVer far *);
	typedef int		(EXPENTRY *_ZpInit)(ZIPUSERFUNCTIONS far * lpZipUserFunc);
	typedef BOOL	(EXPENTRY *_ZpSetOptions)(ZPOPT *Opts);
	typedef ZPOPT	(EXPENTRY *_ZpGetOptions)(void);
	typedef int		(EXPENTRY *_ZpArchive)(ZCL C);

	_ZpVersion ZpVersion;
	_ZpInit ZpInit;
	_ZpSetOptions ZpSetOptions;
	_ZpGetOptions ZpGetOptions;
	_ZpArchive ZpArchive;

	ZIPUSERFUNCTIONS UserFuncs;
	int InitResult;

	static GLogTarget *Log;

	static int WINAPI DllPrint(LPSTR str, unsigned long i);
	static int WINAPI DllComment(LPSTR s);
	static int WINAPI DllPassword(LPSTR str, int i, LPCSTR a, LPCSTR b);
	static int WINAPI DllService(LPCSTR str, unsigned long i);

public:
	GZipLibrary(GLogTarget *log);

	bool IsOk();
	bool Zip(char *ZipFile, char *BaseDir, List<char> &Extensions, char *AfterDate);
};

#endif