#ifndef __IHTTP_H
#define __IHTTP_H

#include "INet.h"

#define GET_TYPE_NORMAL				1
#define GET_TYPE_FILE_HOST			2

class IHttp
{
	char Buffer[1024];
	IConnection *Socket;	// commands
	int ResumeFrom;

public:
	Progress *Meter;

	IHttp();
	virtual ~IHttp();

	void SetResume(int i) { ResumeFrom = i; }

	// Data
	IConnection *Handle() { return Socket; }
	
	// Connection
	bool Open(IConnection *S, char *RemoteHost, int Port = 0);
	bool Close();
	bool IsOpen();

	// File
	bool GetFile(	char *File,
					BytePipe &Out,
					int Format = GET_TYPE_NORMAL,
					int *ProtocolStatus = 0,
					int *Length = 0);
};

#endif