/*hdr
**      FILE:           ILdap.h
**      AUTHOR:         Matthew Allen
**      DATE:           21/6/2000
**      DESCRIPTION:    Open LDAP plugin
**
**      Copyright (C) 2000, Matthew Allen
**              fret@ozemail.com.au
*/

#ifndef __ILDAP_H
#define __ILDAP_H

#include "INet.h"
#include "\CodeLib\openldap-1.2.10\include\lber.h"
#include "\CodeLib\openldap-1.2.10\include\ldap.h"
#include "\CodeLib\openldap-1.2.10\include\ldapconfig.h"

#define LDAP_PORT					389

#define LDAP_ENTRY_PERSON			0x0001
#define LDAP_ENTRY_GROUP			0x0002

class ILdapEntry
{
public:
	char *Name;
	char *Email;
	int Type;

	bool IsGroup() { return TestFlag(Type, LDAP_ENTRY_GROUP); }

	ILdapEntry();
	virtual ~ILdapEntry();
};

class ILdap
{
	LDAP *Ldap;

public:
	ILdap();
	virtual ~ILdap();

	bool Open(char *RemoteServer, int Port = LDAP_PORT);
	bool Close();

	ILdapEntry *RetreiveOne(char *Name);
	bool RetreiveList(List<ILdapEntry> &Entries);
};

#endif