//
//      FILE:           LgiCommon.h
//      AUTHOR:         Matthew Allen
//      DATE:           27/3/2000
//      DESCRIPTION:    Common LGI include
//
//      Copyright (C) 2000, Matthew Allen
//              fret@ozemail.com.au

#if defined LINUX
#include <sys/time.h>
#endif

/////////////////////////////////////////////////////////////
// Externs
LgiFunc void DrawBox(GdcBasePrimitives *pDC, GdcRegion &r, bool Sunken, bool Fill);
LgiFunc void DrawMoveDeepEdge(GdcBasePrimitives *pDC, GdcRegion &r, int Type);
LgiFunc void DrawMoveShallowEdge(GdcBasePrimitives *pDC, GdcRegion &r, int Type);
LgiFunc void DrawMoveFill(GdcBasePrimitives *pDC, GdcRegion &r, int Width = -1);

LgiFunc bool LgiTrimDir(char *Path);
LgiFunc bool LgiGetExeFile(char *Dst);
LgiFunc bool LgiGetExePath(char *Dst);
LgiFunc char *LgiFindFile(char *Name);
LgiFunc int LgiGetLanguageId();
LgiFunc char *LgiLoadString(int Res);
LgiFunc int LgiMsg(GView *Parent, char *Msg, char *Title = 0, int Type = MB_OK, ...);
LgiFunc bool LgiExecute(char *File, char *Arguments="", char *Dir=".");
LgiFunc int LgiRand(int Limit);
LgiFunc bool LgiPlaySound(char *FileName, int Flags);
LgiFunc GToolBar *LgiLoadToolbar(GView *Parent, char *File, int x = 24, int y = 24);
LgiFunc bool LgiGetFileMimeType(char *File, char *Mime);
LgiFunc bool LgiGetAppForMimeType(char *Mime, char *AppPath);
LgiFunc void LgiInitColours();
LgiFunc COLOUR LgiColour(int Colour);
LgiFunc void LgiTrace(char *Format, ...);
LgiFunc int LgiGetOs(int *Ver = 0, int *Rev = 0);
LgiFunc char *LgiGetOsName();
LgiFunc void LgiInitColours();

typedef bool (*RecursiveFileSearch_Callback)(char *Path, VDirectory *);		// return 0 to end search
LgiFunc bool LgiRecursiveFileSearch(char *Root,					// start search in this dir
									List<char> &Ext,			// extensions to match
									List<char> *Files = 0,		// [optional] output filenames
									quad *Size = 0,				// [optional] output total size
									quad *Count = 0,			// [optional] file count
									RecursiveFileSearch_Callback Callback = 0);
																// [optional] callback for match

#if defined WIN32
	#define LgiCurrentTime() (GetTickCount())
#else
	#ifdef LINUX
		extern quad real_time_clock_usecs();
	#endif
	#define LgiCurrentTime() (real_time_clock_usecs() / 1000)
#endif

