//
//      FILE:           LgiDefs.h
//      AUTHOR:         Matthew Allen
//      DATE:           24/9/99
//      DESCRIPTION:    Global LGI include
//
//      Copyright (C) 1999, Matthew Allen
//              fret@ozemail.com.au
//

#ifndef __LGIDEFS_H
#define __LGIDEFS_H

// unsafe typedefs, for backward compatibility
typedef			unsigned char		uchar;
typedef			unsigned short		ushort;
typedef			unsigned int		uint;
typedef			unsigned long		ulong;
typedef			unsigned short		HND;
typedef			unsigned short		MESSAGE;
typedef			__int64				quad;

// Length safe typedesf, use these in new code
typedef			signed char			int8;
typedef			unsigned char		uint8;
typedef			signed short		int16;
typedef			unsigned short		uint16;
typedef			signed int			int32;
typedef			unsigned int		uint32;
typedef			signed __int64		int64;
typedef			unsigned __int64	uint64;

// Boolean
#define TRUE						1
#define FALSE						0

// Basic macros
#define abs(a)						(((a) > 0) ? (a) : -(a))
#define min(a,b)					(((a) < (b)) ? (a) : (b))
#define max(a,b)					(((a) > (b)) ? (a) : (b))
#define limit(i,l,u)				(((i)<(l)) ? (l) : (((i)>(u)) ? (u) : (i)))
#define makelong(a, b)				((a)<<16 | (b&0xFFFF))
#define loword(a)					(a&0xFFFF)
#define hiword(a)					(a>>16)

#ifndef BEOS
#define swap(a, b)					{ int n = a; a = b; b = n; }
#endif

// Operators
#define NOT							!
#define AND							&&
#define OR							||

// Good ol NULLy
#ifndef NULL
#define NULL						0
#endif

// Some objectish ones
#define ZeroObj(obj)				memset(&obj, 0, sizeof(obj))
#define CountOf(array)				(sizeof(array)/sizeof(array[0]))
#define StrEmpty(s)					(s)[0] = 0
#define IsStrEmpty(s)				((NOT s) OR ((s)[0] == 0))

#endif