


#ifndef __LGI_INC_H
#define __LGI_INC_H

#ifdef LGI_STATIC

	// static linking
	#define LgiFunc		extern
	#define LgiClass	
	#define LgiExtern	extern

#else

	// dynamically linked

	#ifdef WIN32

		#ifdef LGI_LIBRARY
			#define LgiFunc		extern "C" __declspec(dllexport)
			#define LgiClass	__declspec(dllexport)
			#define LgiExtern	extern __declspec(dllexport)
		#else
			#define LgiFunc		extern "C" __declspec(dllimport)
			#define LgiClass	__declspec(dllimport)
			#define LgiExtern	extern __declspec(dllimport)
		#endif

	#else // Unix like OS

		#ifdef LGI_LIBRARY
			#define LgiFunc		extern "C"
			#define LgiClass	
			#define LgiExtern	extern
		#else
			#define LgiFunc		extern "C"
			#define LgiClass
			#define LgiExtern	extern
		#endif


	#endif

	// check for LGI_RES defined.
	// the Lgi library is built with LGI_RES defined, all apps
	// must define this to be compatible
	#ifndef LGI_RES
	#error "LGI_RES must be defined in your application"
	#endif

#endif

#endif