///////////////////////////////////////////////////////////////////////
// Multi-language library: LgiRes
//
// To include compile time support for LgiRes add the define "LGI_RES" to
// your project's settings.
#include "Res.h"
#include "Contain.h"

class LgiClass LgiStringRes
{
public:
	int Ref;
	int Id;
	char *Str;
	bool IsString;

	LgiStringRes();
	~LgiStringRes();
	bool Read(List<XmlTag> &Tags);
};

class LgiClass LgiDialogRes
{
public:
	XmlTag *Dialog;
	LgiStringRes *Str;
	GdcRegion Pos;
	List<XmlTag> Tags;

	LgiDialogRes();
	~LgiDialogRes();

	bool Read(List<XmlTag> &l);
	char *Name() { return (Str) ? Str->Str : 0; }
	int Id() { return (Str) ? Str->Id : 0; }
	int X() { return Pos.X(); }
	int Y() { return Pos.Y(); }
};

class LgiClass LgiMenuRes : public GObject
{
public:
	List<XmlTag> Tags;

	LgiMenuRes();
	~LgiMenuRes();

	bool Read(List<XmlTag> &l);
};

class LgiClass LgiResources : public ResFactory
{
public:
	static List<LgiResources> ResourceContainers;
	List<LgiDialogRes> Dialogs;
	List<LgiStringRes> Strings;
	List<LgiMenuRes> Menus;

	LgiResources(char *FileName = 0, bool Warn = false);
	~LgiResources();

	bool Load(char *FileName);
	LgiStringRes *StrFromRef(int Ref);
	char *StringFromRef(int Ref);

	ResObject *CreateObject(char *Name, ResObject *Parent);
	void Res_SetPos(ResObject *Obj, int x1, int y1, int x2, int y2);
	void Res_SetPos(ResObject *Obj, char *s);
	GdcRegion Res_GetPos(ResObject *Obj);
	int Res_GetStrRef(ResObject *Obj);
	void Res_SetStrRef(ResObject *Obj, int Ref);
	void Res_Attach(ResObject *Obj, ResObject *Parent);
	bool Res_GetChildren(ResObject *Obj, List<ResObject> *l, bool Deep);
	void Res_Append(ResObject *Obj, ResObject *Parent);
	bool Res_GetItems(ResObject *Obj, List<ResObject> *l);
	bool Res_GetProperties(ResObject *Obj, ObjProperties *Props);
	bool Res_SetProperties(ResObject *Obj, ObjProperties *Props);
};

LgiExtern LgiResources *LgiGetResObj(bool Warn = false);
