
#ifndef __RES_H
#define __RES_H

// Includes
#include "Xml.h"
#include "Prop.h"

/////////////////////////////////////////////////////////////////////
// Language stuff
#define LangIdEnglish	13

class LangInfo
{
public:
	int Id;
	char *Name;
	int Win32Id;
	char *Win32Define;
};

LgiExtern LangInfo AllLanguages[];
LgiExtern LangInfo *LangFind(char *Define = 0, int Lang = -1, char *Name = 0);

////////////////////////////////////////////////////////////////////
// All the names of the controls as strings
LgiExtern char Res_Dialog[];
LgiExtern char Res_StaticText[];
LgiExtern char Res_EditBox[];
LgiExtern char Res_CheckBox[];
LgiExtern char Res_Button[];
LgiExtern char Res_Group[];
LgiExtern char Res_RadioBox[];
LgiExtern char Res_Tab[];
LgiExtern char Res_TabView[];
LgiExtern char Res_ListView[];
LgiExtern char Res_Column[];
LgiExtern char Res_TreeView[];
LgiExtern char Res_Bitmap[];
LgiExtern char Res_Progress[];
LgiExtern char Res_Slider[];
LgiExtern char Res_ComboBox[];
LgiExtern char Res_ScrollBar[];

// Classes
class ResObjectImpl;
class ResFactory;

class LgiClass ResParent
{
public:
	ResParent() {}
	virtual ~ResParent() {}

	virtual void *GetRealPtr() { return 0; }
};

class LgiClass ResObject : public ResParent
{
private:
	char *_ObjName;
	ResObjectImpl *_ObjImpl;

public:
	ResObject(char *Name);
	virtual ResObjectImpl *GetObjectImpl(ResFactory *f);
};

// Inherit from and implement to create objects for your system
class LgiClass ResFactory
{
public:
	// Use to read and write the objects
	bool Res_Read(ResObject *Obj, List<XmlTag> &Tags);
	bool Res_Write(ResObject *Obj, VFile &f);

	// Overide
	virtual char *StringFromRef(int Ref) = 0;
	virtual ResObject *CreateObject(char *Name, ResObject *Parent) = 0;

	// Overide these to operate on the objects
	virtual void		Res_SetPos		(ResObject *Obj, int x1, int y1, int x2, int y2) = 0;
	virtual void		Res_SetPos		(ResObject *Obj, char *s) = 0;
	virtual GdcRegion	Res_GetPos		(ResObject *Obj) = 0;
	virtual int			Res_GetStrRef	(ResObject *Obj) = 0;
	virtual void		Res_SetStrRef	(ResObject *Obj, int Ref) = 0;
	virtual void		Res_Attach		(ResObject *Obj, ResObject *Parent) = 0;
	virtual bool		Res_GetChildren	(ResObject *Obj, List<ResObject> *l, bool Deep) = 0;
	virtual void		Res_Append		(ResObject *Obj, ResObject *Parent) = 0;
	virtual bool		Res_GetItems	(ResObject *Obj, List<ResObject> *l) = 0;
	
	// Property access
	virtual bool		Res_GetProperties(ResObject *Obj, ObjProperties *Props) = 0;
	virtual bool		Res_SetProperties(ResObject *Obj, ObjProperties *Props) = 0;
};

#endif
