#include <stdlib.h>
#include <stdio.h>

#include "Lgi.h"
#include "GAbout.h"

#define USE_GTEXTVIEW

#ifdef USE_GTEXTVIEW
#include "GTextView2.h"
class AboutText : public GTextView
{
public:
	AboutText(	int Id,
				int x,
				int y,
				int cx,
				int cy,
				GView *notify = 0,
				char *appname = 0,
				GdcFontType *FontInfo = 0) :
		GTextView(Id, x, y, cx, cy, notify, appname, FontInfo)
	{
		ReadOnlyBackColour = LC_MED;
	}
};
#endif

//////////////////////////////////////////////////////////////////////////////
#define IDM_WEB				100
#define IDM_BMP				101

GAbout::GAbout(	GView *parent,
				char *AppName,
				double Ver,
				char *Text,
				char *AboutGraphic)
{
	SetParent(parent);
	if (NOT AppName) AppName = "Application";

	char Str[512];
	sprintf(Str, "About %s", AppName);
	Name(Str);

	#ifdef _DEBUG
	char *Build = "Debug";
	#else
	char *Build = "Release";
	#endif

	sprintf(Str,
			"%s v%02.2f (%s %s)\n"
			"Build: %s, %s\n"
			"\n"
			"http://members.ozemail.com.au/~fret\n"
			"fret@ozemail.com.au\n"
			"\n"
			"%s",
			AppName,
			Ver,
			LgiGetOsName(),
			Build,
			__DATE__,
			__TIME__,
			Text?Text:(char*)"");

	int x = 10;
	if (AboutGraphic)
	{
		char *FileName = LgiFindFile(AboutGraphic);
		if (FileName)
		{
			Children.Insert(NEW(GBitmap(IDM_BMP, 10, 10, FileName, true)));
			DeleteArray(FileName);
			x += 170;
		}
	}

	Pos.ZOff(210 + x, 210);

	#ifdef USE_GTEXTVIEW
	GdcFontType Type;
	AboutText *Ctrl = 0;
	Type.GetSystemFont("System");

	Children.Insert(Ctrl = NEW(AboutText(IDM_STATIC, x, 10, 190, 145, this, AppName, &Type)));
	if (Ctrl)
	{
		Ctrl->AcceptEdits(false);
		Ctrl->Name(Str);
		Ctrl->SetCursor(strlen(Str), false);

		GdcPt2 Size;
		Ctrl->GetTextExtent(Size);
		Size.x += 4;
		Size.y += 4;

		GdcRegion r = Ctrl->GetPos();
		if (Size.x > r.X() OR Size.y > r.Y())
		{
			int Dx = Size.x - r.X();
			int Dy = Size.y - r.Y();

			if (Dx > 0) Pos.x2 += Dx;
			if (Dy > 0) Pos.y2 += Dy;

			r.Dimension(Size.x-1, Size.y-1);
			Ctrl->SetPos(r);
		}
	}

	#else
	Children.Insert(NEW(GText(IDM_STATIC, x, 10, 190, 145, Str)));
	#endif

	MoveToCenter();
	Children.Insert(NEW(GButton(IDOK, Pos.X()-65, Pos.Y()-50, 50, 20, "Ok")));

	DoModal();
}

int GAbout::OnNotify(GView *Ctrl, int Flags)
{
	switch (Ctrl->GetId())
	{
		case IDOK:
		{
			EndModal(0);
			break;
		}
	}
	return 0;
}

