#include "Lgi.h"

GLibrary::GLibrary(char *File)
{
	FileName = 0;
	hLib = 0;
	if (File)
	{
		Load(File);
	}
}

GLibrary::~GLibrary()
{
	Unload();
}

bool GLibrary::Load(char *File)
{
	Unload();

	if (File)
	{
		char f[256];
		strcpy(f, File);
		
		// check for default extension..
		// if you specify no extension in the application this will correctly set
		// it for the OS your running thus removing the need for #ifdef's in your
		// app. sweet!
		char *Dot = strrchr(f, '.');
		if (NOT Dot OR strchr(Dot, DIR_CHAR))
		{
			strcat(f, _SysDefLibExtension);
		}

		FileName = NewStr(f);
		if (FileName)
		{
			#if defined WIN32
			hLib = LoadLibrary(FileName);
			#elif defined BEOS
			hLib = load_add_on(FileName);
			#endif
		}
	}

	return hLib != 0;
}

bool GLibrary::Unload()
{
	if (hLib)
	{
		#ifdef WIN32
		FreeLibrary(hLib);
		#elif defined BEOS
		unload_add_on(hLib);
		#endif
		hLib = 0;
	}

	DeleteArray(FileName);

	return true;
}

void *GLibrary::GetAddress(char *Resource)
{
	if (Resource AND hLib)
	{
		#ifdef WIN32
		return GetProcAddress(hLib, Resource);
		#elif defined BEOS
		void *Addr = 0;
		if (get_image_symbol(hLib, Resource, B_SYMBOL_TYPE_TEXT, (void**) &Addr) == B_OK)
		{
			return Addr;
		}
		#endif
	}

	return 0;
}

