/*
**	FILE:			GProgressStatusPane.cpp
**	AUTHOR:			Matthew Allen
**	DATE:			13/12/1999
**	DESCRIPTION:	Progress meter for the status bar
**
**	Copyright (C) 1999, Matthew Allen
**		fret@ozemail.com.au
*/

#include <stdio.h>
#include "Lgi.h"
#include "GProgressStatusPane.h"

////////////////////////////////////////////////////////////////////////////////
GProgressStatusPane::GProgressStatusPane() : DoEvery(200)
{
	SetWidth(100);
	Sunken(true);
}

GProgressStatusPane::~GProgressStatusPane()
{
}

void GProgressStatusPane::OnPaint(GdcBasePrimitives *pDC)
{
	GdcRegion r(0, 0, Pos.X()-1, Pos.Y()-1);
	int Off = 1;

	if (Sunken())
	{
		Off = 0;
		DrawMoveShallowEdge(pDC, r, SUNKEN);
	}

	pDC->Colour(LC_MED, 24);
	pDC->Box(&r);
	r.Size(1, 1);
	pDC->Box(&r);
	r.Size(1, 1);

	double Pos = (High != Low) ? (double) Val / ((double) High - (double) Low) : 0;
	int x = r.X() * Pos;
	if (x < r.X())
	{
		pDC->Rectangle(r.x1+x, r.y1, r.x2, r.y2);
	}

	pDC->Colour(LC_SELECTION, 24);
	pDC->Rectangle(r.x1, r.y1, r.x1+x-1, r.y2);
}

int GProgressStatusPane::Value()
{
	return Progress::Value();
}

void GProgressStatusPane::Value(int v)
{
	Progress::Value(v);

	if (DoNow() OR NOT v)
	{
		GView::Invalidate();
		#ifdef WIN32
		GApp::ObjInstance()->Run(false);
		#endif
	}
}

