/*hdr
**      FILE:           GTabView.cpp
**      AUTHOR:         Matthew Allen
**      DATE:           28/6/99
**      DESCRIPTION:    Resizing Tab View
**
**      Copyright (C) 1999, Matthew Allen
**              fret@ozemail.com.au
*/

#include <stdio.h>

#include "Lgi.h"
#include "GTabView.h"

GTabView::GTabView() :
	GTabControl(100, 0, 0, 100, 100, "GTabView")
{
}

GTabView::~GTabView()
{
}

bool GTabView::Pour(GdcComplexRegion &r)
{
	GdcRegion *Best = FindLargest(r);
	if (Best)
	{
		SetPos(*Best);
		return true;
	}
	return false;
}

void GTabView::OnPosChange()
{
	GTabControl::OnPosChange();
	
	for (GTabPage *Page = Tabs.First(); Page; Page = Tabs.Next())
	{
		// GdcRegion Rgn(GetClient());
		GdcRegion Rgn(Page->GetPos());
		Rgn.Offset(-Rgn.x1, -Rgn.y1);
		GdcComplexRegion r(Rgn);

		for (GView *w = Page->Children.First(); w; w = Page->Children.Next())
		{
			GLayout *v = dynamic_cast<GLayout*>(w);
			if (v)
			{
				v->Pour(r);
			}
		}
	}
}

