// Applicator stuff


// servers
class GdcSetServer : public GdcApplicatorServer {
public:
	int Op() { return GDC_SET; }
	GdcApplicator *Create(int Bits);
};

class GdcAndServer : public GdcApplicatorServer {
public:
	int Op() { return GDC_AND; }
	GdcApplicator *Create(int Bits);
};

class GdcOrServer : public GdcApplicatorServer {
public:
	int Op() { return GDC_OR; }
	GdcApplicator *Create(int Bits);
};

class GdcXorServer : public GdcApplicatorServer {
public:
	int Op() { return GDC_XOR; }
	GdcApplicator *Create(int Bits);
};


// 8 bit applicators
class GdcApp8 : public GdcApplicator {
protected:
	uchar *Ptr;

public:
	bool SetSurface(GdcSurface *d, GdcPalette *p, GdcSurface *a);
	void SetPtr(int x, int y);
	void IncX();
	void IncY();
	void IncPtr(int X, int Y);
	COLOUR Get();
};

class GdcApp8Set : public GdcApp8 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp8And : public GdcApp8 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp8Or : public GdcApp8 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp8Xor : public GdcApp8 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

// 15 bit applicators
class GdcApp15 : public GdcApplicator {
protected:
	uchar *Ptr;

public:
	bool SetSurface(GdcSurface *d, GdcPalette *p, GdcSurface *a);
	void SetPtr(int x, int y);
	void IncX();
	void IncY();
	void IncPtr(int X, int Y);
	COLOUR Get();
};

class GdcApp15Set : public GdcApp15 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp15And : public GdcApp15 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp15Or : public GdcApp15 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp15Xor : public GdcApp15 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

// 16 bit applicators
class GdcApp16 : public GdcApplicator {
protected:
	uchar *Ptr;

public:
	bool SetSurface(GdcSurface *d, GdcPalette *p, GdcSurface *a);
	void SetPtr(int x, int y);
	void IncX();
	void IncY();
	void IncPtr(int X, int Y);
	COLOUR Get();
};

class GdcApp16Set : public GdcApp16 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp16And : public GdcApp16 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp16Or : public GdcApp16 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp16Xor : public GdcApp16 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

// 24 bit applicators
class GdcApp24 : public GdcApplicator {
protected:
	uchar *Ptr;

public:
	bool SetSurface(GdcSurface *d, GdcPalette *p, GdcSurface *a);
	void SetPtr(int x, int y);
	void IncX();
	void IncY();
	void IncPtr(int X, int Y);
	COLOUR Get();
};

class GdcApp24Set : public GdcApp24 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp24And : public GdcApp24 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp24Or : public GdcApp24 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp24Xor : public GdcApp24 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

// 32 bit applicators
class GdcApp32 : public GdcApplicator {
protected:
	ulong *Ptr;

public:
	bool SetSurface(GdcSurface *d, GdcPalette *p, GdcSurface *a);
	void SetPtr(int x, int y);
	void IncX();
	void IncY();
	void IncPtr(int X, int Y);
	COLOUR Get();
};

class GdcApp32Set : public GdcApp32 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp32And : public GdcApp32 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp32Or : public GdcApp32 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class GdcApp32Xor : public GdcApp32 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};
