/*hdr
**	FILE:		Memory.h
**	AUTHOR:		Matthew Allen
**	DATE:		30/11/93
**	DESCRIPTION:	Memory subsystem header
**
**
**	Copyright (C) 1995, Matthew Allen
**		55 Kensignton Rd, Bolwarra, 2320, NSW, Australia
**		fret@ozemail.com.au
*/

#ifndef __MEMORY_H
#define __MEMORY_H

#include <string.h>
#include "LibDefs.h"
#include "LgiOsDefs.h"
#include "Device.h"

// #define MEMORY_DEBUG

#ifdef MEMORY_DEBUG

	extern void *operator		new(unsigned size, char *file, int line);
	extern void *operator		new[](unsigned size, char *file, int line);
	#define NEW(obj)		new(__FILE__, __LINE__) obj
	extern void operator		delete(void *p);

#else

	#define NEW(obj)		new obj

#endif

#define DeleteObj(obj)		if (obj) { delete obj; obj = 0; }
#define DeleteArray(obj)	if (obj) { delete [] obj; obj = 0; }

class MemoryDevice : public GDevice {

public:
	MemoryDevice();
	~MemoryDevice();

	static int GetFreeMemory() { return 0; }
};

extern void MemorySizeToStr(char *Str, uint Size);

#endif
